#ifndef _IS_THIS_CATMULL_HEADER_DEFINED_
#define _IS_THIS_CATMULL_HEADER_DEFINED_

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <linux/ps2/dev.h>
#include <ps2vpufile.h>
#include <ps2vpu.h>
#include "micro.vh"
#include "aidoru_types.h"

/* compute the catmull-rom interpolation point */
void catmull_rom3d(ps2_vu0_fvector dest,
                   const ps2_vu0_fvector c,
                   ps2_vu0_fvector x,
                   ps2_vu0_fvector y,
                   ps2_vu0_fvector z);

/* indices for catmull-rom lookup table */
#define CR_U25 0 /* 25% of the way between points 2 and 3 */
#define CR_U50 1 /* halfway between point 2 and 3 */
#define CR_U75 2 /* 75% of the way between points 2 and 3 */

/* precomputed catmull-rom u constants for 0.25 0.5 and 0.75 */
static const ps2_vu0_fvector cr_consts[3] = 
                       {{-0.0703125,0.8671875,0.2265625,-0.0234375},
                        {-0.0625,0.5625,0.5625,-0.0625},
                        {-0.0234375,0.226563,0.8671875,-0.0703125}};

#endif
