#ifndef _IS_THIS_PS2INIT_HEADER_DEFINED_
#define _IS_THIS_PS2INIT_HEADER_DEFINED_

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <linux/ps2/dev.h>
#include <ps2vpu.h>
#include <ps2vpufile.h>
#include "micro.vh"
#include "debugging.h"

/* reset vector unit 0 */
#define VU0_Reset() asm __volatile__ (".set noat ; cfc2. $1,$28 ; ctc2. %0,$28 ; sync.p ; or $1, $1, 12 ; ctc2. $1, $28 ; sync.p ; .set at"::"r"(2));

/* size and address of VU's amd SPRAM */
#define VU0_SIZE 8192
#define VU1_SIZE 32768
#define SPRAM_SIZE 16384
#define SPRAM_ADDR (void*)0x70000000

/* my own struct for holding hardware handles and ptrs */
typedef struct
{ 
  int vu0;
  int vu1;
  void *vu0mem;
  void *vu1mem;
  int pad0;
  int spr;
  int event; 
}ps2hardware;

int ps2init(char*, ps2hardware*);
int ps2close(ps2hardware);

#endif
