#include "states.h"
#include "tests.h"
#include "neural_mlfn.h"

/* for those of you new to state machines,
   here is a fun little sample program
*/

int update_AI(void)
{
  static mlfn_net *net;

  STATE_MACHINE
    /* global init code goes here */
    SET_STATE(STATE_CAT_TEST)
  
  IF_STATE(STATE_CAT_TEST)
     test_catmull_rom();
     SET_STATE(STATE_NEURAL_TEST);
  END_STATE

  IF_STATE(STATE_NEURAL_TEST)
     BEGIN_INIT_CODE
        system("./netgen testnet.mlfn 2 3 2");
        if (net = load_mlfn("testnet.mlfn",net,CREATE))
          printf("\n\nMLFN neural net tests\nsuccessfully initialized");
     END_INIT_CODE
     mlfn_net_test(net);        
     SET_STATE(STATE_QUIT_NOW)
  END_STATE
  
  IF_STATE(STATE_QUIT_NOW)
     printf("\n\nexit! performing DMA cleanup\n");
     destroy_mlfn_net(net);
     if (debug_leaks(GET_DMA_COUNT) != NO_LEAKS)
       printf("\nmemory leak found!");
     else
       printf("\nno memory leaks found! Did you remember to always use \nDEBUG_MALLOC and DEBUG_FREE instead of malloc and free???\n\n");
     return(GAME_OVER);
  END_STATE

  END_STATE_MACHINE
  
  /* I threw this in to make the compiler happy  =(^_-)=  */
  return(0);
}
