#ifndef _IS_THIS_STATES_HEADER_DEFINED_
#define _IS_THIS_STATES_HEADER_DEFINED_

/* exit from my set of tests */
#define GAME_OVER 0

/* states can only be 7 bits... 8th bit is reserved */
#define STATE_MASK 0x7F     /* clear the new state bit */
#define NEW_STATE_BIT 0x80  /* set when you first come to a state */

/* sample states for the demo - do not use in real code */
#define STATE_CAT_TEST 1
#define STATE_NEURAL_TEST 2
#define STATE_QUIT_NOW 3

/* Every function has its own set of 
   states but they all have this one.
   State 0 is always reserved for this  
*/
#define STATE_BEGIN 0

/* my own macro state language */
#define STATE_MACHINE static unsigned char _current_state =                                                              STATE_BEGIN | NEW_STATE_BIT;                      if (_current_state == (STATE_BEGIN | NEW_STATE_BIT)) {
                  
                                                     

#define SET_STATE(_st) _current_state = _st;                                                      _current_state |= NEW_STATE_BIT;                                           return(1);

#define IF_STATE(_st) } else if ((_current_state & STATE_MASK) == _st) { 

#define END_STATE return(1); 

#define BEGIN_INIT_CODE if (_current_state & NEW_STATE_BIT) {                                          _current_state &= STATE_MASK;

#define END_INIT_CODE }

#define END_STATE_MACHINE return(0); }

/* update game AI each tick */
int update_AI(void);

#endif
