#include "tests.h"

int test_catmull_rom(void)
{
  ps2_vu0_fvector v1 __attribute__ ((aligned (16)));
  ps2_vu0_fvector v2 __attribute__ ((aligned (16)));
  ps2_vu0_fvector v3 __attribute__ ((aligned (16))); 
  ps2_vu0_fvector dest __attribute__ ((aligned (16)));

  v1[0] = 1; v1[1] = 2; v1[2] = 4; v1[3] = 8;
  v2[0] = 1; v2[1] = 2; v2[2] = 2; v2[3] = 1;
  v3[0] = -8; v3[1] = -4; v3[2] = -2; v3[3] = -1;
  dest[0] = 0; dest[1] = 0; dest[2] = 0; dest[3] = 0;

  printf("\nCatmull-Rom test:\noriginal points:");

  printf("\n(%f, %f, %f)\n(%f, %f, %f)\n(%f, %f, %f)\n(%f, %f, %f)", 
	                                          v1[0],v2[0],v3[0],
                                                  v1[1],v2[1],v3[1],
                                                  v1[2],v2[2],v3[2],
                                                  v1[3],v2[3],v3[3]);   
     
  catmull_rom3d(dest,cr_consts[CR_U50],v1,v2,v3);
  
  printf("\nnew point: (%f, %f, %f)", dest[0], dest[1], dest[2]); 
  
  return(0);
}

int mlfn_net_test(mlfn_net *net)
{
  /* test fwd propagation */
  mlfn_fwd_propagate(net);
  /* make sure file is saved correctly */
  printf("\n\ntesting saved file");
  save_mlfn("testsave.mlfn",net);
  system("diff --brief testnet.mlfn testsave.mlfn");
  
  return(0);
}
